v3.0 RC12
 - Bug Fix: [FS#121] Humans can teleport while planting
 - Bug Fix: [FS#81-6] Wrong ultimate charge was being removed (it attempted to remove it from the caster vs. the nearby player with immunity)
 - Bug Fix: [FS#83] Changed respawn method to use Ham
 - Bug Fix: [FS#105] Serpent Ward removal on incorrect event call 

v3.0 RC11b
 - Bug Fix: [FS#109] DoD crash on shopmenu

v3.0 RC11
 - Addition: [FS#92] solution against detecting moles (angle of view)
 - Bug Fix: [FS#97] Removing Human's devotion aura
 - Bug Fix: MySQLX error logging incorrect in some places (reporting wrong query)
 - Bug Fix: [FS#83] Respawn within a player. Respawn dead
 - Bug Fix: [FS#85] Add alive check before kill by SH (patch FS#76)
 - Bug Fix: [FS#88] Always allow chameleon to buy ankh
 - Bug Fix: [FS#95] ITEM_MOLE should disappear when used
 - Bug Fix: Fixed Admin Commands reporting back incorrectly in wc3_admin.log
 - Bug Fix: [FS#96] CT Chameleons with backpack
 - Bug Fix: [FS#90] Locust Swarm didn't attack after finding new target
 - Bug Fix: [FS#89] allow pov-targeting ultimate to work quickly
 - Bug Fix: [FS#102] Chain Lightning actually hits only one enemy
 - Bug Fix: [FS#79] fix invalid player in client_damage()

v3.0 RC10
 - Addition: [FS#68] Playerskills will now print to console if called from console
 - Bug Fix: MYSQLX error function was being called from within SQLITE
 - Bug Fix: [FS#72] Run time error in items.inl
 - Bug Fix: [FS#62] Level 10 sprite wasn't being precached
 - Bug Fix: [FS#60][DOD] Server crash when buying flaming gloves of warmth
 - Bug Fix: Bots casting their ultimate is actually random now, not everytime they attack
 - Bug Fix: If chain lightning was blocked, the wrong person would be notified
 - Bug Fix: [FS#17] Big Bad Voodoo never working
 - Bug Fix: Mole protectant not working
 - Bug Fix: Database spamming problem when a user's ID couldn't be retreived
 - Bug Fix: [FS#76] Hex wasn't disabling all skills
 - Bug Fix: When checking a user's skills the level and skill id were not being matched correctly (in XP_Check)

v3.0 RC9
 - Addition: [FS#29] Client console commands for all items
 - Addition: [FS#59][WEB] Rank based on TOTAL XP - "total" option added to config file
 - Bug Fix: [FS#46] Immolate not doing the proper amount of damage
 - Bug Fix: [FS#47] Warden's Hardened skin was not working correctly
 - Bug Fix: [FS#48] Fixed undead's ultimate going off when hexed
 - Bug Fix: [FS#66] Server crash when using wc3_giveitem with item_id over 17
 - Bug Fix: [FS#63] Server crash on given maps b/c of sprite count
 - Bug Fix: [FS#57] cl_minmodels check failure
 - Bug Fix: [FS#70] g_iSpawnReserved index out of bounds
 - Bug Fix: [FS#67] Mole is shown to spectators when mole is in slot2
 - Bug Fix: Respawn failing with AMXX 1.80
 - Bug Fix: Menus not working with AMXX 1.80
 - Bug Fix: [FS#65] Stuck protection triggered after new round started
 - Bug Fix: [FS#55] Command /levitation now available for any race with skill levitation
 - Bug Fix: [FS#54] Sock item always set gravity to 0.5 (wc3_sock value ignored)
 - Bug Fix: [FS#53] Deselected skills are no longer saved to database (will be saved as skill level as 0)
 - Bug Fix: [FS#35] Player couldn't respawn after WC3_Kill (generally after warden ultimate)
 - Bug Fix: [FS#26] If warden is killed last and immunity check should not occur (i.e. killer shouldn't lose a necklace charge)
 - Bug Fix: [WEB] Searching based on steam id or player name wasn't working

v3.0 RC8
 - Bug Fix: [FS#25] Warden's Shadow Strike had wrong percentage at level 1
 - Bug Fix: [FS#31] Reset item charges when a player joins the server
 - Bug Fix: [FS#28] rings console command not going through proper checks
 - Bug Fix: [FS#32] Giving XP to terrorists in admin menu would not work
 - Bug Fix: [FS#21] Friendly fire no longer affects charges for helm of excellence
 - Bug Fix: [FS#37] Undead ultimate run time error
 - Bug Fix: [FS#38] Grenade trail created on orc's death when grenade drops
 - Bug Fix: [FS#40] Assist XP awarded twice if a user would respawn

v3.0 RC7
 - Addition: wc3_ignore_bots CVAR which works with wc3_min_players (thanks Krazy)
 - Addition: It is now possible do deal damage against a SH w/Big Bad Voodoo if you have immunity
 - Addition: Log file for war3ft exclusive use
 - Addition: (B2) [FS#7] When you respawn with weapons your silence/burst mode will be remembered and set
 - Addition: (B2) wc3_start_level CVAR - You can now start a player's race off at a certain level when they join the server
 - Bug Fix: Gloves not always working correctly
 - Bug Fix: XP Loss at map change
 - Bug Fix: (B2) cl_minmodels check failing at certain times (thanks DesasterUK)
 - Bug Fix: (B2) Conversion issue when war3users table didn't exist (thanks Coksnuss)
 - Bug Fix: (B2) Getting stuck in a wall from Banish or failed Teleport - you should now be teleported back to your spawn (if possible) instead of left stuck
 - Bug Fix: (B2) Big Bad Voodoo works now - opps
 - Bug Fix: (B2) Ankh/Mole will no longer work if you replace the item
 - Bug Fix: (B2) Saving by IP will not strip the port from the address
 - Bug Fix: (B2) [FS#14] Locust swarm icon continuously blink in a certain situation
 - Bug Fix: (B2) Admin logging wasn't logging the actual command
 - Bug Fix: (B2) Passive skills were being saved to the database
 - Bug Fix: (B2) Was incorrectly calculating the player's ID in _SH_ResetBigBadAttacker (thanks [DumB]SGR)
Note: Please delete your wc3_web_skill table if you had a previous version of 3.0 running and are using MySQL

v3.0 RC6
 - Addition: levitation console command
 - Addition: Message now displayed when human's ultimate is blocked
 - Addition: Check for correct race when using /levitation
 - Addition: Forward - wc3_reportkill
 - Addition: Admin logging added (/configs/war3ft/wc3_admin.log)
 - Addition: Boot cvar
 - Bug Fix: Possible for ultimate icon to stay after a searching ultimate was used (if on last second of search)
 - Bug Fix: Message to warden regarding Blink could be repeated
 - Bug Fix: Ultimate icons not always showing
 - Bug Fix: Reset skills message appearing on EVERY changerace
 - Bug Fix: Ultimate cooldown timer set wrong at round start
 - Bug Fix: Ultimate icon not shown when you first select your race
 - Bug Fix: Human's ultimate was blocked WAY more than it should have been (would always be blocked if anyone had immunity)
 - Bug Fix: Possible to remove multiple Necklace charges from Orc's ultimate
 - Bug Fix: Bots not always given a race/XP right away
 - Bug Fix: Human health set to 190 w/listen servers (thanks DesasterUK)
 - Bug Fix: Invisibility disappearing after use of Big Bad Voodoo (thanks mattypee)
 - Bug Fix: Changerace menu not appearing when joining server on listen server (thanks DesasterUK)
 - Bug Fix: Assist XP giving too much
 - Bug Fix: Pending changerace never reset when a player disconnected (thanks kevlartester)
 - Bug Fix: When giving Xp through admin command it wasn't always set correctly (thanks EchoSide)
 - Bug Fix: Changing wc3_save_xp or wc3_xp_multiplier in game will no longer require a map restart to take affect
 - Bug Fix: (B6) Loss of XP when changerace menu wouldn't appear
 - Bug Fix: (B6) cs_deagle5 issue with weapon reincarnation
 - Bug Fix: (B6) Being able to get XP after the round has ended (thanks Krazy)
 - Change: (B6) Changerace screen will now load instantly (not using threaded query)
 - Change: Respawn time from 1.5 seconds to 0.2 (by ability or item)
 - Change: Bots skin will change now if they mole or buy chameleon
 - Change: (B5) No longer set maximum money to 16000 when setting money
 - Removed: NVault support - default is now SQLite
 - Removed: Purchasing items when moling (was removing buyzones for others)
 - Re-write: How ultimate icons are handled

v3.0 RC5
 - Bug Fix: Getting more health than you should with Devotion Aura
 - Bug Fix: Run-time errors from RC4 which made it unplayable

v3.0 RC4
 - Addition: Changerace will now work with CSDM
 - Addition: resetskills will now work with CSDM
 - Addition: Appropriate messages for resetskills/changerace (instead of next round now says when respawn)
 - Addition: /levitation command to enable/disable levitation
 - Addition: Changerace menu will appear after other menus are done (i.e. so you can choose CSDM then war3ft)
 - Bug Fix: Using wc3_bot_buy_item didn't actually work - bots could never buy items
 - Bug Fix: Setting wc3_bot_buy_item to 0 should disable the feature but it wasn't (thanks mexykanu + YamiKaitou)
 - Bug Fix: Bug with warden and planting the bomb (thanks damian086pl)
 - Bug Fix: (DOD) Buyzone was attempted to be created when a player would mole
 - Bug Fix: (DOD) Runtime error in WC3_Death
 - Bug Fix: Runtime error - http://wc3mods.net/forums/viewtopic.php?t=2281
 - Bug Fix: Possible for new player to gain xp assist while spectating (thanks kp_downarrow)
 - Bug Fix: Possible to use shopmenu2 with <= 4 races (thanks strawbewwy)
 - Bug Fix: Armor was not given back when respawning
 - Bug Fix: Kills not saved when you kill someone by an ability
 - Bug Fix: Selecting ultimate w/selectskills before the ultimatedelay is up will display the icon but you can't use ult
 - Bug Fix: Was possible to have ult when < level 6 if your xp dropped below level 6 after having the ult
 - Bug Fix: runtime error - invalid player - with SHARED_SetUserMoney
 - Bug Fix: Chameleon random skills not working...
 - Bug Fix: (DOD) Stamina bar going crazy w/unholy aura
 - Bug Fix: Mole given every round if the user didn't die (thanks DesasterUK for testing this)
 - Bug Fix: Possible to remain a Phoenix (to respawn a teammate) after you lost the ability
 - Bug Fix: Orc's reincarnation would break w/CSDM
 - Bug Fix: Possibility of respawning abilities conflicting w/CSDM
 - Bug Fix: Shadow Hunter's healing ward was healing too often (function was running twice)
 - Change: Boots now stack with unholy aura
 - Change: XP given by kill assist is now lowered
 - Change: Additional $$ is given per kill if csdm is active
 - Change: Shadow Strike is no longer limited to 3 per round (but the % chance of it occuring is less)
 - Change: Carrion Beetles are no longer limited to 3 per round (but the % chance of it occuring is less)
 - Change: Number of necklace charges given increased to 4

To-dos/Bug Fixes:
 - to do - show detailed skill information in /skillsinfo
 - to do - write WC3_InitPlayerItems
 - to do - chameleon randomize per player basis
 - bug - if u lose levitation it won't actually go down ( - do i really care?)
 - bugs: /level shown in ShowMsg or whatev for dod
 - to do - DOD - if user just joined - they shouldn't be able to buy ankh
 - test: dod's reincarnation changes... - give item back if fails?
 - to do - in SM_SetSkill we need to call WC3_InitPlayerSkills
  - serpent wards display thing overlaps (when you place one)

v3.0 RC3
 - Addition: Sock of the feather stacks with Undead's Levitation (suggestion by YamiKaitou)
 - Addition: Costs of items now depends on the player's level
 - Bug Fix: After choosing an option on a menu, a radio command is executed or an item is bought (thanks p3tsin/VEN)
 - Bug Fix: Mask of death not doing anything (thanks zverj)
 - Bug Fix: Wasn't possible to buy a tomb of experience if you had 2 items (thanks snapdoodle)
 - Bug Fix: Tomb would display that you gained XP even if you didn't (i.e. no other players in server)
 - Bug Fix: Runtime error - [0] shared.inl::_SHARED_SpawnRemoveGod (line 336) (thanks Striker)
 - Bug Fix: Sock of the feather would over-rule undead's levitation even if it was worse (thanks YamiKaitou)
 - Bug Fix: Undead's levitation would not work after being respawned after death (thanks Saint K)
 - Bug Fix: If multiple offensive items were purchased - only one would work (thanks snapdoodle)
 - Bug Fix: MySQL connections never closed on map change (thanks Saint K)
 - Bug Fix: Can now purchase tome when dead (thanks Saint K)

v3.0 RC2
 - Addition: Help file explaining how to configure chameleon (file is: /configs/war3ft/_chameleon.txt)
 - Addition: Added check for wc3.css on server start (plugin will not load without it)
 - Addition: Players will now gain XP for kill assists!
 - Bug Fix: Players running at same speed with all weapons
 - Bug Fix: Boots of speed was same speed for all weapons, changed to bonus 10% increase per weapon
 - Bug Fix: Fixed configuration issues with setting chameleon's races, also added a file explaining how to use it
 - Bug Fix: Nearby player's weren't given XP for a nearby teammate killing someone
 - Bug Fix: Rings not giving health
 - Bug Fix: Periapt wasn't giving health at round start
 - Bug Fix: Ankh would stay in items if purchased when dead (but it wouldn't work)
 - Bug Fix: Flash grenades will reincarnate now
 - Bug Fix: Weapons will now reincarnate if you are killed by the bomb
 - Bug Fix: Undead's levitation busted when pcvar wasn't found
 - Change: Bot XP will now save if saving is done by name
 - Change: Item handling
 - Removed: Nearby XP bonus when a nearby player kills someone

v3.0 RC1
 - Addition: Start/Stop command: amx_wc3 <on|off>
 - Addition: If a needed module isn't loaded, the plugin will modify the modules.ini + reload the map
 - Addition: NVault now used instead of vault (will improve lag when there are NUMEROUS users and saving XP is on)
 - Addition: Check for serpent wards to prevent them from being planted on the bomb or on hostages
 - Addition: amx_setlevel has been added
 - Addition: /level10 command - gives level 10 when you type it (if sv_cheats is on, don't worry, this XP doesn't save into the database...)
 - Addition: (DOD) Chameleon now works!
 - Addition: (DOD) Mole's will change their model
 - Addition: Users will be given god mode for 1 second after they respawn
 - Addition: Plugin will now auto-load even if modules aren't enabled, thanks BAIL!
 - Addition: Plugin will no longer load if any required sound files or sprites are missing
 - Addition: /icons now saves on the client (using setinfo) so (in theory) joining any war3ft 3.0 server will know if you want /icons on or off
 - Addition: When typing /level when dead, the user's XP will be shown
 - Bug Fix: cl_minmodels task was not repeating
 - Bug Fix: Spawning with a shield and primary weapon
 - Bug Fix: User's speed not changed until switching weapons when unholy aura was selected
 - Change: Entire re-write of how skills function (can anyone say uwc3 extension?)
 - Change: Spectating info now changes when you switch people (sometimes it wouldn't always switch over)
 - Change: Spectating info will no longer carry over when the next round starts
 - Change: With mole protectant you can now view players names during freezetime by looking at them
 - Change: You now gain XP when nearby teammates kill an enemy!
 - Change: Mole's can now buy items when they have moled!!
 - Change: Helm of Excellence price increase to 3000
 - Change: Chameleon race can now have ANY skills (not just a subset of that skill number like before)
 - Change: User cannot be given money to have more than $16000
 - Change: Chameleon price dropped to 4500
 - Change: Tome gives more XP when saving XP is on
 - Change: Impale now hits the user up from the ground
 - Change: Banish will now move an attacker into an atral prison
 - Change: Scroll of Respawning cost lowered
 - Change: You can now hold 2 items from either shopmenu!!!
 - Change: Unstable Concoction now originates from the attacker and damages nearby teammates
 - Change: Using Vengeance will ALWAYS set your health to 50
 - Change: Cloak stacks with invisibility
 - Change: Config file location moved
 - Change: When weapon reincarnation's weapons are saved - fixed weapons not reincarnating when you're killed by the bomb
 - Change: When a user spawns their money is not longer set to mp_startmoney (for CS/CZ)
 - Change: All DB functions re-written (Now uses MySQL X, NVault, SQLite)
 - Change: Blood Mage has a new ultimate! - thanks Avanderik
 - Change: Avanderik added to developer check
 - Change: Traceline is used when searching for a target for certain ultimates (instead of get_user_aiming every .1 seconds)
 - Change: Bash chance has been reduced to 10%/20%/30%
 - Change: Evasion and Helm will now flash your screen blue instead of previous colors
 - Change: Orc critical nades will now have a max damage of the user's maximum possible health - 1
 - Change: You will no longer lose your ankh/scroll of respawning if someone respawns you by Phoenix or warden's ultimate
 - Change: Bash now holds for 0.7 seconds instead of 1.0
 - Change: Humans can no longer teleport into the VIP Escape zone
 - Change: A recompile is no longer required for a DOD/CS/CZ plugin
 - Change: Necklace now has charges (3)
 - Change: When an ultimate is blocked b/c of immunity, the user has to wait for the length of the cooldown to re-use
 - Removed: FT_impale_intensity cvar (edit this constant at the top of skills.inl)
 - Removed: FT_blink_radius cvar (replaced with NECKLACE_RADIUS define)
 - Removed: FT_healing_range cvar (defined at top of skills.inl)
 - Removed: FT_no_orcnades cvar
 - Removed: Human's teleport (Blink is the ultimate)
 - Removed: Cheating Death check
 - Removed: FT_spec_info (default is on, compile time option at top of warcraft3ft.sma)
 - Removed: FT_items_in_hud (option no longer available)
 - Removed: FT_show_icons (always on)
 - Removed: FT_centerhud (this actually hasn't done anything for quite a few versions)
 - Removed: DOD_bootspeed (you can change it at the top of items.inl)
 - Removed: sv_warcraft3 (added a start/stop option)
 - Removed: PRECACHE_WAR3FTSOUNDS define, precached sounds are required

//update saving system to allow for uwc3?
//clear items on death - the hud message
//use CSX for custom weapons?
//test: spec info disappearing and re-appearing after 10.0 seconds
//re-write menus
//during banish switch to knife?
//clean up items
//verify all skills given with selectskill
//allow user to changerace when in spec?
//Fix bug with doing autoselect w/FT_Races 8 then changerace and CENTER_CHANGED_NEXT displaying
//remove all task_exists
//fix hex playing after ur dead...
//bug: phoenix will try to respawn users when changing team
//block knife = http://forums.alliedmods.net/showthread.php?t=29836
//skill manager re-write needed

//shopmenu 3 ideas:
// immune to some magic
// immune to physical damage
// show invis peeps...
// lower ultimate cooldown
